# Constraints on obstacle positions
problems = {
    'bisect': [
        ((-1, -0), (-1, 1))
        ],
    'circle':  [
        ((0, 0), (0.5)),
        ],
    'corners': [
        ((1, 1), (0.40)),
        ((1, -1), (0.40)),
        ((-1, -1), (0.40)),
        ((-1, 1), (0.40)),
        ],
    'cross': [
        ((-0.1875, 0.1875), (0, 0.7)),
        ((-0.1875, 0.1875), (-0.7, 0)),
        ((-0.7, 0), (-0.1875, 0.1875)),
        ((0, 0.7), (-0.1875, 0.1875)),
        ],
    'einstein_tile': [
        ((-0.40, 0), (-0.825, -0.25), (-0.70, -0.50)), 
        ((-0.40, 0), (-0.40, -0.50), (-0.70, -0.50)), 
        ((-0.40, 0), (-0.40, -0.50), (-0.10, -0.50)), 
        ((-0.40, 0), (0.08, -0.25), (-0.10, -0.50)),     
        ((-0.40, 0), (0.08, -0.25), (0.25, 0)),          
        ((0.50, -0.50), (0.08, -0.25), (0.25, 0)),       
        ((0.50, -0.50), (0.5, 0), (0.25, 0)),         
        ((0.50, -0.50), (0.5, 0), (0.75, 0)),          
        ((0.50, -0.50), (0.90, -0.25), (0.75, 0)),    
        ((0.50, 0.50), (0.50, 0), (0.25, 0)),          
        ((0.50, 0.50), (0, 0.25), (0.25, 0)),         
        ((0.50, 0.50), (0, 0.25), (-0.10, 0.50)),      
        ((0.50, 0.50), (0.10, 0.75), (-0.10, 0.50)),   
        ((-0.40, 0), (0, 0.25), (-0.10, 0.50)),           
        ((-0.40, 0), (-0.40, 0.50), (-0.10, 0.50)),       
        ((-0.40, 0), (0, 0.25), (0.25, 0)),  
        ],
    'quarters': [
        ((-1, -0.450), (-0.20, 0.20)),
        ((-0.20, 0.20), (0.450, 1)),
        ((0.450, 1), (-0.20, 0.20)),
        ((-0.20, 0.20), (-1, -0.450)),
        ],
    'scatter': [
        ((0.55, 0), (0.15)),
        ((0.45, 0.70), (0.15)),
        ((-0.60, 0.3), (0.15)),
        ((-0.15, -0.65), (0.15)),
        ],
    'stellaris': [
        ((0.5, 0.5), (0.45)),
        ((-0.15, -0.675), (0.225)),
        ((-0.625, 0.175), (0.175)),
        ((-0.0375, 0), (0.1125)),
        ((-0.125, 0.475), (0.075)),
        ],
    }

def get_problem_list():
    return list(problems.keys())

def get_problem_instance(instance_name):
    instance_constr = problems[instance_name]
    return instance_constr